import { FC, ReactNode } from "react";
import { ArchetypeQueryOrComponentList, UntypedEntity, World } from ".";
import { IEntity } from "./World";
export declare function createECS<TEntity extends IEntity = UntypedEntity>(): {
    world: World<TEntity>;
    useArchetype: (...query: ArchetypeQueryOrComponentList<TEntity>) => import("./Archetype").Archetype<TEntity>;
    useEntity: () => TEntity;
    Entity: FC<{
        children: ReactNode | ((entity: TEntity) => JSX.Element);
        entity?: TEntity | undefined;
    }>;
    Component: <K extends keyof TEntity>({ name, data }: {
        name: K;
        data: TEntity[K];
    }) => null;
    MemoizedEntity: FC<{
        entity: TEntity;
    }>;
    Entities: FC<{
        children: ReactNode | ((entity: TEntity) => JSX.Element);
        entities: TEntity[];
        memoize?: boolean | undefined;
    }>;
    Collection: FC<{
        children: ReactNode | ((entity: TEntity) => JSX.Element);
        initial?: number | undefined;
        tag: keyof TEntity;
        memoize?: boolean | undefined;
    }>;
};
